require "phys.lua" -- contains physics calcs & other main-game everything
require "title.lua" -- contains code for the title screen & character select

function love.load()

   GAME_LOADING = 0
   GAME_TITLE = 1
   GAME_CHARSELECT = 2
   GAME_MAIN = 3
   GAME_GAMEOVER = 4
   GAME_HISCORE = 5

   game_mode = GAME_LOADING

   i = 0



end


function load_game()

love.graphics.setFont( "georgia.ttf", 16 )

   love.filesystem.setIdentity( "gravmage" )

   -- variables in lowercase, constants in uppercase

   angle = 0 -- initialize some variables
   distance = 0
   player_score = 0

   GHOST_INCREASE_TIMER = 20 -- seconds till another ghost is added

   BDY_CENTER = -1
   BDY_WALLS = 0
   BDY_PELLET = -2
   BDY_PELLETA = -2
   BDY_PELLETB = -3
   BDY_GHOST = 1

   -- pull methods
   PULL_GRAVITY = 1
   PULL_ELASTIC = 2
   PULL_CONSTANT = 3
   
   method = 0

   sound = love.audio.newSource( "COD_HIT.wav", "static" )
   crash = love.audio.newSource( "COD_HIT2.wav", "static" )

   decoder = love.sound.newDecoder( "prime&some1-turtle_race.mod", 1024, 11025)
   musicdata = love.sound.newSoundData(decoder)
   music = love.audio.newSource( musicdata )
   music:setLooping(true)
   music:setVolume(1)
   love.audio.play(music)

   part1 = love.graphics.newImage("part1.png");

	parts1 = love.graphics.newParticleSystem(part1, 1000)
	parts1:setEmissionRate(500)
	parts1:setSpeed(100, 200)
	parts1:setSize(1, .5)
	parts1:setColor(220, 105, 20, 255, 194, 30, 18, 0)
	parts1:setPosition(400, 300)
	parts1:setLifetime(0.1)
	parts1:setParticleLife(0.2)
	parts1:setDirection(0)
	parts1:setSpread(360)
	parts1:stop()

	parts2 = love.graphics.newParticleSystem(part1, 1000)
	parts2:setEmissionRate(500)
	parts2:setSpeed(100, 200)
	parts2:setSize(1, .5)
	parts2:setColor(220, 105, 20, 255, 194, 30, 18, 0)
	parts2:setPosition(400, 300)
	parts2:setLifetime(0.1)
	parts2:setParticleLife(0.2)
	parts2:setDirection(0)
	parts2:setSpread(3)
	parts2:stop()

   titlescreen = love.graphics.newImage("title.png")
   allchars = love.graphics.newImage("charselect.png")
   charsl = love.graphics.newImage("char_l.png")
   charsm = love.graphics.newImage("char_m.png")
   charsr = love.graphics.newImage("char_r.png")
   coreimage = love.graphics.newImage("core.png")
   core1image = love.graphics.newImage("core1.png")
   core2image = love.graphics.newImage("core2.png")
   ghost1 = love.graphics.newImage("ghost_1.png")
   ghost2 = love.graphics.newImage("ghost_2.png")
   ghost3 = love.graphics.newImage("ghost_3.png")
   pelletimg = love.graphics.newImage("pellet.png")

   game_mode = GAME_TITLE

end



function love.update(dt)

-- Make sure we draw loading screen before actually loading
 if game_mode == GAME_LOADING then 
   if i == 1 then
     load_game()
   else
     i = i + 1
   end
 end

 if game_mode == GAME_TITLE
 or game_mode == GAME_CHARSELECT 
 or game_mode == GAME_GAMEOVER 
 or game_mode == GAME_HISCORE then

   -- we wait for love.mousepressed in title.lua to kick us to game_main

 end

 if game_mode == GAME_MAIN then
 
  if player_life <= 0 then
    game_mode = GAME_GAMEOVER
  end

  if player_life < 1000 then
    player_life = player_life + .1
  end

  world:update(dt) --this puts the world into motion

  -- This is where the magic happens!

  ax = body[BDY_PELLETA]:getX()
  ay = body[BDY_PELLETA]:getY()
  bx = body[BDY_PELLETB]:getX()
  by = body[BDY_PELLETB]:getY()
  cx = body[BDY_CENTER]:getX()
  cy = body[BDY_CENTER]:getY()
  mx = love.mouse.getX()
  my = love.mouse.getY() 

  parts1:update(dt)
  parts2:update(dt)

  if method == PULL_CONSTANT then
    constantattract()
  end

  if method == PULL_ELASTIC then
    elasticattract()
  end

  if method == PULL_GRAVITY then  
    gravityattract()
  end

  ghosttimerb = love.timer.getTime()
  if ghosttimerb - ghosttimera >= GHOST_INCREASE_TIMER and MAX_GHOST < 15 then
   MAX_GHOST = MAX_GHOST + 1
   ghosttimera = love.timer.getTime()
  end

  ghostspawn()

 end

end


function love.draw()

 if game_mode == GAME_LOADING then
   drawloading()
 elseif game_mode == GAME_MAIN then
    drawgame()
 elseif game_mode == GAME_CHARSELECT then
    drawcharselect()
 elseif game_mode == GAME_TITLE then
    drawtitle()
 elseif game_mode == GAME_GAMEOVER then
    drawgameover()
 elseif game_mode == GAME_HISCORE then
    drawhiscore()
 end  

end