function worldsetup()

   -- Creates all the shapes and such that the game uses

   player_life = 1000
   player_score = 0
   MAX_GHOST = 2
   ghosttimera = love.timer.getTime()


   world = love.physics.newWorld(1000, 1000)
   world:setGravity(0,0)
   world:setCallbacks(add, persist, rem, result)

   body = {}
   shp_ghost = {}   

   for i = 0, 15 do
     body[BDY_GHOST + i] = love.physics.newBody(world, -100, -100, 1, 1) --> create enemy object offscreen
     body[BDY_GHOST + i]:putToSleep() --> and sleepify it
     shp_ghost[i] = love.physics.newCircleShape(body[BDY_GHOST + i], 10)
     shp_ghost[i]:setData(BDY_GHOST + i)
     shp_ghost[i]:setMask(2) --> ghosts won't collide with each other
     shp_ghost[i]:setCategory(2)
   end

   body[BDY_CENTER] = love.physics.newBody(world, 400, 300, 0, 1)
   shp_center = love.physics.newCircleShape(body[BDY_CENTER], 24)
   shp_center:setData(BDY_CENTER)

   body[BDY_WALLS] = love.physics.newBody(world, 400, 300, 0, 0)

   shp_wallsa = love.physics.newRectangleShape(body[BDY_WALLS], 0, -300, 800, 10, 0)
   shp_wallsa:setData(BDY_WALLS)
   shp_wallsb = love.physics.newRectangleShape(body[BDY_WALLS], 0, 300, 800, 10, 0)
   shp_wallsb:setData(BDY_WALLS)
   shp_wallsc = love.physics.newRectangleShape(body[BDY_WALLS], -400, 0, 10, 600, 0)
   shp_wallsc:setData(BDY_WALLS)
   shp_wallsd = love.physics.newRectangleShape(body[BDY_WALLS], 400, 0, 10, 600, 0)
   shp_wallsd:setData(BDY_WALLS)

   body[BDY_PELLETA] = love.physics.newBody(world, 400, 100, 10, 1)
   body[BDY_PELLETA]:setBullet(true)
   shp_BDY_PELLETA = love.physics.newCircleShape(body[BDY_PELLETA], 10)
   shp_BDY_PELLETA:setData(BDY_PELLET)
   shp_BDY_PELLETA:setMask(3) --> pellet won't collide with the center
   shp_BDY_PELLETA:setCategory(3)

   body[BDY_PELLETB] = love.physics.newBody(world, 400, 200, 10, 1)
   body[BDY_PELLETB]:setBullet(true)
   shp_BDY_PELLETB = love.physics.newCircleShape(body[BDY_PELLETB], 10)
   shp_BDY_PELLETB:setData(BDY_PELLET)
   shp_BDY_PELLETB:setMask(3) --> pellet won't collide with the center
   shp_BDY_PELLETB:setCategory(3)

   shp_center:setCategory(3)

   body[BDY_PELLETA]:setLinearVelocity(75, 0)
   body[BDY_PELLETB]:setLinearVelocity(-25, 0)

end


function ghostspawn() 
-- puts ghosts on the field and sets them moving towards the center

   for i = 0, MAX_GHOST - 1 do
     if body[BDY_GHOST + i]:getX() < 0 then
	 position = math.random() * (2 * math.pi)
       body[BDY_GHOST + i]:setY((math.sin(position) * 300) + 300)
       body[BDY_GHOST + i]:setX((math.cos(position) * 300) + 400)
	 body[BDY_GHOST + i]:setAngle(position)
	 body[BDY_GHOST + i]:wakeUp() --> rise from your grave
	 body[BDY_GHOST + i]:applyImpulse((body[BDY_CENTER]:getX() - body[BDY_GHOST + i]:getX())/ 300, (body[BDY_CENTER]:getY() - body[BDY_GHOST + i]:getY())/ 300, body[BDY_GHOST + i]:getX(), body[BDY_GHOST + i]:getY())

     end
   end

end


-- This models attraction between A and B as elastic EG pull INCREASES with distance
function elasticattract()
     body[BDY_PELLETA]:applyForce(cx - ax, cy - ay, ax, ay)
     body[BDY_PELLETB]:applyForce(cx - bx, cy - by, bx, by)

     if love.mouse.isDown( 'l' ) then
           body[BDY_PELLETA]:applyForce(mx - ax, my - ay, ax, ay)
           body[BDY_PELLETB]:applyForce(mx - bx, my - by, bx, by)
     end
end

-- This models attraction between A and B as gravitational EG pull DECREASES with distance
function gravityattract()

  gravpow = -3000000
  gravmult = 2

  distx = (cx - ax )
  disty = (cy - ay )
  distance = math.sqrt( math.pow(distx, 2) + math.pow(disty,2))
  angle = math.atan2(disty, distx) + math.pi
  gravdivisor = math.max(gravpow / math.pow(distance, gravmult), -10000)
  body[BDY_PELLETA]:applyForce( math.cos(angle) * gravdivisor, math.sin(angle) * gravdivisor, ax, ay)

  distx = (cx - bx )
  disty = (cy - by )
  distance = math.sqrt( math.pow(distx, 2) + math.pow(disty,2))
  angle = math.atan2(disty, distx) + math.pi
  gravdivisor = math.max(gravpow / math.pow(distance, gravmult), -10000)
  body[BDY_PELLETB]:applyForce( math.cos(angle) * gravdivisor, math.sin(angle) * gravdivisor, bx, by)

  if love.mouse.isDown( 'l' ) then

    distx = (mx - ax )
    disty = (my - ay )
    distance = math.sqrt( math.pow(distx, 2) + math.pow(disty,2))
    angle = math.atan2(disty, distx) + math.pi
    gravdivisor = math.max(gravpow / math.pow(distance, gravmult), -10000)
    body[BDY_PELLETA]:applyForce( math.cos(angle) * gravdivisor, math.sin(angle) * gravdivisor, ax, ay)

    distx = (mx - bx )
    disty = (my - by )
    distance = math.sqrt( math.pow(distx, 2) + math.pow(disty,2))
    angle = math.atan2(disty, distx) + math.pi
    gravdivisor = math.max(gravpow / math.pow(distance, gravmult), -10000)
    body[BDY_PELLETB]:applyForce( math.cos(angle) * gravdivisor, math.sin(angle) * gravdivisor, bx, by)

  end
end



function constantattract()
  distx = (cx - ax )
  disty = (cy - ay )
  distance = math.sqrt( math.pow(distx, 1) + math.pow(disty,1))
  angle = math.atan2(disty, distx) + math.pi
  debuga = math.cos(angle)
  debugb = math.sin(angle)
  body[BDY_PELLETA]:applyForce( math.cos(angle) * -100, math.sin(angle) * -100, ax, ay)

  distx = (cx - bx )
  disty = (cy - by )
  distance = math.sqrt( math.pow(distx, 1) + math.pow(disty,1))
  angle = math.atan2(disty, distx) + math.pi
  debuga = math.cos(angle)
  debugb = math.sin(angle)
  body[BDY_PELLETB]:applyForce( math.cos(angle) * -100, math.sin(angle) * -100, bx, by)

  if love.mouse.isDown( 'l' ) then

    distx = (mx - ax )
    disty = (my - ay )
    distance = math.sqrt( math.pow(distx, 1) + math.pow(disty,1))
    angle = math.atan2(disty, distx) + math.pi
    debuga = math.cos(angle)
    debugb = math.sin(angle)
    body[BDY_PELLETA]:applyForce( math.cos(angle) * -100, math.sin(angle) * -100, ax, ay)

    distx = (mx - bx )
    disty = (my - by )
    distance = math.sqrt( math.pow(distx, 1) + math.pow(disty,1))
    angle = math.atan2(disty, distx) + math.pi
    debuga = math.cos(angle)
    debugb = math.sin(angle)
    body[BDY_PELLETB]:applyForce( math.cos(angle) * -100, math.sin(angle) * -100, bx, by)

  end
end

function drawgame()

		love.graphics.setColorMode("modulate")

  love.graphics.setColor(255, 255, 255) --set the drawing color to white

  love.graphics.print("Click and hold to add a second attractor", 10, 15)
  love.graphics.print("Life:", 10, 30)
  love.graphics.rectangle( "line", 70, 20, 100, 10 )
  love.graphics.rectangle( "fill", 70, 20, (player_life / 10), 10 )
  love.graphics.print("Score:", 10, 45)
  love.graphics.print(player_score, 60, 45)

   love.graphics.draw(coreimage, body[BDY_CENTER]:getX(), body[BDY_CENTER]:getY(), 0, 1, 1, 32, 32)

  --love.graphics.circle("fill", body[BDY_PELLETA]:getX(), body[BDY_PELLETA]:getY(), shp_BDY_PELLETA:getRadius(), 6)
  --love.graphics.circle("fill", body[BDY_PELLETB]:getX(), body[BDY_PELLETB]:getY(), shp_BDY_PELLETB:getRadius(), 6)
  love.graphics.draw(pelletimg, body[BDY_PELLETA]:getX(), body[BDY_PELLETA]:getY(), 0, 1, 1, 16, 16)
  love.graphics.draw(pelletimg, body[BDY_PELLETB]:getX(), body[BDY_PELLETB]:getY(), 0, 1, 1, 16, 16)

  if love.mouse.isDown( 'l' ) then
    love.graphics.circle("fill", love.mouse.getX(), love.mouse.getY(), 5, 10)
  end

 for i = 0, MAX_GHOST - 1 do
  --love.graphics.circle("fill", body[BDY_GHOST + i]:getX(), body[BDY_GHOST + i]:getY(), shp_ghost[i]:getRadius(), 6)
    love.graphics.draw(ghost1, body[BDY_GHOST + i]:getX(), body[BDY_GHOST + i]:getY(), 0, 1, 1, 16, 16)
 end




		love.graphics.setBlendMode("additive")


bub = player_life * 256 / 1000
if bub > 255 then bub = 255 end
if bub < 0 then bub = 0 end
love.graphics.setColor(bub, bub, bub) --modulate core bubble by current life

love.graphics.draw(coreimage, body[BDY_CENTER]:getX(), body[BDY_CENTER]:getY(), 0, 1, 1, 32, 32)

love.graphics.setColor(255, 255, 255) --set the drawing color to white


		love.graphics.setBlendMode("additive")
		
		love.graphics.draw(parts1, 0, 0)	
		love.graphics.draw(parts2, 0, 0)	

		love.graphics.setBlendMode("alpha")

if method == PULL_CONSTANT then
   love.graphics.draw(core2image, body[BDY_CENTER]:getX(), body[BDY_CENTER]:getY(), 0, 1, 1, 32, 32)
else
   love.graphics.draw(core1image, body[BDY_CENTER]:getX(), body[BDY_CENTER]:getY(), 0, 1, 1, 32, 32)
end

end

-- Collision information for main game
function add(a, b, coll)

  if b == BDY_PELLET and a == BDY_WALLS then --> pellet hit something
	--love.audio.stop(sound)
      --love.audio.play(sound)
  end

  if b == BDY_PELLET and a >= BDY_GHOST then --> pellet hit ghost
	love.audio.stop(sound)
      love.audio.play(sound)

	parts1:setPosition(body[a]:getX(), body[a]:getY())
	parts1:start()

	body[a]:setLinearVelocity(0, 0)
      body[a]:putToSleep()
      body[a]:setX(-100)
      player_score = player_score + 10

  end

  if b == BDY_CENTER and a >= BDY_GHOST then --> ghost hit center
	love.audio.stop(crash)
      love.audio.play(crash)

	parts2:setPosition(body[a]:getX(), body[a]:getY())
	parts2:setDirection(body[a]:getAngle())
	parts2:start()

	body[a]:setLinearVelocity(0, 0)
      body[a]:putToSleep()
      body[a]:setX(-100)
      player_life = player_life - 200
  end

end