-- contains code for the title screen, character select, and loading screen

function drawtitle()
  love.graphics.setColor(255, 255, 255)  
  --love.graphics.setColor(255, 255, 255) --set the drawing color to white
  --love.graphics.printf("Gravity Mage", 0, 200, 800, "center")
  --love.graphics.printf("Left-click anywhere to start", 0, 300, 800, "center")
  --love.graphics.printf("Right-click to see high scores", 0, 315, 800, "center")
  love.graphics.draw(titlescreen, 0, 0)
end

function drawloading()
  love.graphics.printf("Loading...", 0, 300, 800, "center")
end

function drawhiscore()
  love.graphics.setColor(255, 255, 255) --set the drawing color to white
  love.graphics.printf("High Scores", 0, 15, 800, "center")

  listhiscores()
end

function drawgameover()
  love.graphics.setColor(255, 255, 255) --set the drawing color to white
  love.graphics.printf("Game Over", 0, 300, 800, "center")
  love.graphics.printf("Final Score:", 0, 350, 800, "center")
  love.graphics.printf(player_score, 0, 365, 800, "center")
end

function drawcharselect()
   love.graphics.setColor(255, 255, 255) --set the drawing color to white
   love.graphics.printf("Choose your Wizard", 0, 15, 800, "center")
   love.graphics.print("f = (mass x mass) / distance ^ 2", 50, 500)
   love.graphics.print("Gravity-like pull", 50, 520)
   love.graphics.print("f = distance", 300, 500)
   love.graphics.print("Elastic-like pull", 300, 520)
   love.graphics.print("f = 100", 533, 500)
   love.graphics.print("Constant pull", 533, 520)


  love.graphics.draw(allchars, 0, 0)

if love.mouse.getX() < 266 then
  --love.graphics.circle("fill", 133, 250, 100, 10)
  love.graphics.draw(charsl, 0, 0)
elseif love.mouse.getX() > 533 then
  --love.graphics.circle("fill", 666, 250, 100, 10)
  love.graphics.draw(charsr, 0, 0)
else 
  --love.graphics.circle("fill", 400, 250, 100, 10)  
  love.graphics.draw(charsm, 0, 0)
end



end


function love.mousepressed(x, y, button)

  if game_mode == GAME_CHARSELECT then
    if love.mouse.getX() < 266 then
      method = PULL_GRAVITY
    elseif love.mouse.getX() > 533 then
      method = PULL_CONSTANT
    else 
      method = PULL_ELASTIC
    end
    worldsetup()
    game_mode = GAME_MAIN
  elseif game_mode == GAME_TITLE then
    if button == 'l' then
      game_mode = GAME_CHARSELECT
    elseif button == 'r' then
      loadhiscores()
      game_mode = GAME_HISCORE
    end
  elseif game_mode == GAME_HISCORE then
    game_mode = GAME_TITLE
  elseif game_mode == GAME_GAMEOVER then
    loadhiscores()
    appendscore()
    game_mode = GAME_HISCORE
  end

end


function loadhiscores()

  hiscore_scores = {} -- score
  hiscore_wizard = {} -- character used
  if love.filesystem.exists( "hiscores.txt" ) then
    -- read scores from file
    file = love.filesystem.newFile("hiscores.txt")
    file:open('r')
    currentline = file:lines()
    for i = 1, 10 do
      if file:eof() then -- Did something weird happen? BAIL OUT
        hiscore_scores = { 1000, 900, 800, 700, 600, 500, 400, 300, 200, 100}
        hiscore_wizard = { 1, 2, 3, 2, 3, 2, 1, 2, 3, 2 }
        file:close()
        break
      end
      hiscore_wizard[i] = tonumber(currentline())
      hiscore_scores[i] = tonumber(currentline())
    end
    file:close()

  else
    -- BS ten scores from scratch
    hiscore_scores = { 1000, 900, 800, 700, 600, 500, 400, 300, 200, 100}
    hiscore_wizard = { 1, 2, 3, 1, 2, 3, 1, 2, 3, 1 }
  end

end

function listhiscores() -- draws hi score table on screen

  love.graphics.print("Character", 150, 100)
  love.graphics.print("Score", 350, 100)

  for i = 1, 10 do
    -- print scores 1 - 10
    if i == playerposition then
	love.graphics.setColor(math.random(0,255), math.random(0,255), math.random(0,255)) --seizure colors
    else
	love.graphics.setColor(255, 255, 255)   
    end

    love.graphics.print(i, 100, 115 + (15 * i))    
    if hiscore_wizard[i] == 1 then
	love.graphics.print("Ghost", 150, 115 + (15 * i))
    elseif hiscore_wizard[i] == 2 then
	love.graphics.print("Namae", 150, 115 + (15 * i))
    else
	love.graphics.print("Alex", 150, 115 + (15 * i))
    end

    -- love.graphics.print("" .. hiscore_wizard[i], 150, 115 + (15 * i))

    love.graphics.print("" .. hiscore_scores[i], 350, 115 + (15 * i))

  end

  -- print player's score at the bottom if appropriate
  if player_score > 0 and playerposition == 11 then
    love.graphics.setColor(math.random(0,255), math.random(0,255), math.random(0,255)) --seizure colors

    if hiscore_wizard[11] == 1 then
	love.graphics.print("Ghost", 150, 350)
    elseif hiscore_wizard[11] == 2 then
	love.graphics.print("Namae", 150, 350)
    else
	love.graphics.print("Alex", 150, 350)
    end

    --love.graphics.print("" .. hiscore_wizard[11], 150, 350)
    love.graphics.print("" .. hiscore_scores[11], 350, 350)
  end

end

function appendscore() -- adds player's score to hi score table and saves it if it's worth the trouble
  playerposition = 0

  for i = 1, 10 do
    if player_score > hiscore_scores[i] then
      table.insert(hiscore_wizard, i, method)
      table.insert(hiscore_scores, i, player_score)
      playerposition = i
      break
    end
  end

  -- replace hiscores.txt with current tables in memory
    file = love.filesystem.newFile("hiscores.txt")
    file:open('w')
    for i = 1, 10 do
	file:write(hiscore_wizard[i] .. "\r\n")
	file:write(hiscore_scores[i] .. "\r\n")
    end
    file:close()

  -- didn't make the list? 11th place, which isn't saved.
  if playerposition == 0 then
    playerposition = 11
    table.insert(hiscore_scores, 11, player_score)
    table.insert(hiscore_wizard, 11, method)
  end

end

